# Если вы новичок в Limb3...
## Основные идеи
Limb3 — это не монолитный фреймворк, как например, Symfony. Limb3 состоит из набора осносительно независимых [пакетов](./packages_architecture.md), каждый из которых должен решает свою задачу.

Limb3 должен быть установлен в папку, которая доступна через [include_path](http://ru2.php.net/manual/en/ini.core.php#ini.include-path). Вы можете или поправить настройки в php.ini или же назначить include_path где-то в конфигурационном скрипте проекта:

    <?php
    ...
    set_include_path('path/to/directory/with/limb/' . PATH_SEPARATOR . get_include_path());
    ...

'path/to/directory/with/limb' должен указывать на папку, где лежит limb, а не на саму папку с limb, например, ~dev/lib/ вместо ~dev/lib/limb/.

## Примеры для начинающих
Для освоения Limb3 есть 2 пошаговых примера:

* [базовый пример](./codebits.md), где показаны только самые основы использования пакетов WEB_APP, ACTIVE_RECORD и MACRO.
* [пример создания простого электронного магазина](./codebits.md), в котором объяснены почти все часто используемые компоненты Limb3.

## Где скачать Limb3
Если вы не собираетесь участвовать в разработке Limb3, то самым простым способом можно получить Limb3 через PEAR канал. На PEAR канале выкладываются самые стабильные релизы и они появляются там наиболее рано. Однако Limb3 также можно получить с sourceforge.net и с build-сервера. см. раздел [Где и как скачать Limb3](./how_to_download.md).

## Документация
Документация на Limb3 достаточно актуальна. Наиболее точными являются раздел про [использование ACTIVE_RECORD](../../active_record/docs/ru/active_record.md). Эти разделы мы рекомендуем прочитать после прохождения [базового примера](./tutorials/basic.md).

Также есть [описания на большинство пакетов Limb3](./packages.md). В этих разделах информация частично, а кое-где и сильно, устарела. Хотя мы постепенно исправляем ситуацию, но это требует очень много времени, и поэтому прогресс идет достаточно медленно. Так что, если что-то из этих разделов будет вам неясным, то можете спрашивать на [форуме](http://forum.limb-project.com/) — мы стараемся отвечать на большинство вопросов оперативно и развернуто.

## Модульные тесты
Для большинства классов и подсистем Limb3 существуют модульные тесты. Разработчики знакомые с тестированием смогут найти множество примеров использования тех или иных классов в тестах. Подробнее о тестах и способах их запуска можно прочитать в [соответствующем разделе](./how_to_run_tests.md).

## Варианты использования Limb3
Вы можете использовать Limb3 как полностью законченный фреймворк, создавая на его базе приложения или же использовать из него только отдельные пакеты, например:

* TESTS_RUNNER — пакет для запуска тестов
* ACTIVE_RECORD — имплементация паттерна [ActiveRecord](http://en.wikipedia.org/wiki/ActiveRecord), позволяющая прозрачно отражать объекты в реляционную БД
* MACRO — шаблонизатор
* TOOLKIT — инструмент для управления зависимостями
* и т.д.

## Требования к хостингу
С требованиями к среде, в которой будет работать Limb3, вы можете ознакомится на [соответствующей странице](./claim.md).

## Если вам нужна помощь
Не стесняйтесь, спрашивайте на [форуме](http://forum.limb-project.com/). Мы всегда постараемся ответить на ваши вопросы.
