# {{label}}
## Описание
Расширенная форма html тега <label>.

Является наследником от [lmb_macro_form_element_tag](./lmb_macro_form_element_tag.md).

Смысл использования этого MACRO-тега только в том, чтобы подсвечивать <label> специальным цветом (или еще как) при наличии ошибки валидации в элементе формы, если эта валидация производится на стороне сервера.

## Синтаксис

    {{label for='control_tag_name' [errorclass='css_class'] [errorstyle='error_style']}}
    ...some content
    {{/label}}

## Содержимое
Любое. Обычно только текст.

## Атрибуты
* **for** — указывает идентификатор поля, к которому относится <label>.
* **errorclass (опционально)** — указывает название CSS класса, которое получает <label>, если поле, к которому <label> относится содержит ошибку валидации.
* **errorstyle (опционально)** — указывает стиль, которое получает <label>, если поле, к которому <label> относится содержит ошибку валидации.

## Область применения
Внутри тега [{{form}}](./form_tag.md).

## Пример использования

    {{form name='my_form'}}
       {{label for='price' errorclass='error_label'}} Price: {{/label}}
       {{input type='text' name="price" id="price"/}}
    {{/form}}
